using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MCL_USB_To_IO;

namespace MclIoExm
{
    public partial class Form1 : Form
    {

        MCL_USB_To_IO.USB_IO MyIO = new MCL_USB_To_IO.USB_IO();
        byte[] ByteArr = new byte[8];
        int status;
        string PortName;

        public Form1()
        {
            InitializeComponent();
        }



        private byte CalcByte()
        {
            byte result = 0;
           
           
            for (int i = 0; i < 8; i++)  
            {
                
                //tmp = Convert.ToByte(Math.Pow(Convert.ToDouble(2), Convert.ToDouble(i)));
                result +=  (byte)( ByteArr[i] * Math.Pow(2,i)); 

            }

            return result;

        }


        








        private void Form1_Load(object sender, EventArgs e)
        {
            string SN = "";
            int i;
            status = MyIO.Connect(ref(SN));

            for (i = 0; i < 8; i++)
            {
                ByteArr[i] = 0;
            }


            b0.BackColor = Color.Red;
            b1.BackColor = Color.Red;
            b2.BackColor = Color.Red;
            b3.BackColor = Color.Red;
            b4.BackColor = Color.Red;
            b5.BackColor = Color.Red;
            b6.BackColor = Color.Red;
            b7.BackColor = Color.Red;


        }

        private void PortA_CheckedChanged(object sender, EventArgs e)
        {
            PortName = "A";
            status = MyIO.Set_ByteA_As_Output();
        }

        private void PortB_CheckedChanged(object sender, EventArgs e)
        {
            PortName = "B";
            status = MyIO.Set_ByteB_As_Output();
        }

        private void b0_Click(object sender, EventArgs e)
        {
            if (ByteArr[0] == 0)
            {
                ByteArr[0] = 1;
                b0.BackColor = Color.Green;

            }
            else
            {
                ByteArr[0] = 0;
                b0.BackColor = Color.Red;
            }
        }

        private void b1_Click(object sender, EventArgs e)
        {
            if (ByteArr[1] == 0)
            {
                ByteArr[1] = 1;
                b1.BackColor = Color.Green;

            }
            else
            {
                ByteArr[1] = 0;
                b1.BackColor = Color.Red;
            }
        }

        private void b2_Click(object sender, EventArgs e)
        {
            if (ByteArr[2] == 0)
            {
                ByteArr[2] = 1;
                b2.BackColor = Color.Green;

            }
            else
            {
                ByteArr[2] = 0;
                b2.BackColor = Color.Red;
            }
        }

        private void b3_Click(object sender, EventArgs e)
        {
            if (ByteArr[3] == 0)
            {
                ByteArr[3] = 1;
                b3.BackColor = Color.Green;

            }
            else
            {
                ByteArr[3] = 0;
                b3.BackColor = Color.Red;
            }
        }

        private void b4_Click(object sender, EventArgs e)
        {
            if (ByteArr[4] == 0)
            {
                ByteArr[4] = 1;
                b4.BackColor = Color.Green;

            }
            else
            {
                ByteArr[4] = 0;
                b4.BackColor = Color.Red;
            }
        }

        private void b5_Click(object sender, EventArgs e)
        {
            if (ByteArr[5] == 0)
            {
                ByteArr[5] = 1;
                b5.BackColor = Color.Green;

            }
            else
            {
                ByteArr[5] = 0;
                b5.BackColor = Color.Red;
            }
        }

        private void b6_Click(object sender, EventArgs e)
        {
            if (ByteArr[6] == 0)
            {
                ByteArr[6] = 1;
                b6.BackColor = Color.Green;

            }
            else
            {
                ByteArr[6] = 0;
                b6.BackColor = Color.Red;
            }
        }

        private void b7_Click(object sender, EventArgs e)
        {
            if (ByteArr[7] == 0)
            {
                ByteArr[7] = 1;
                b7.BackColor = Color.Green;

            }
            else
            {
                ByteArr[7] = 0;
                b7.BackColor = Color.Red;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte SetByte = CalcByte();
            switch (PortName)
            {



                case "A":
                    {
                        status = MyIO.Set_ByteA(ref(SetByte));
                        break;
                    }


                case "B":
                    {
                        status = MyIO.Set_ByteB(ref(SetByte));
                        break;
                    }

                default:
                    break;


            }

        }

       
    }
}