#include "mclIoExample.h"

typedef interface tagMCLUSBToIO__USB_IO_Interface MCLUSBToIO__USB_IO_Interface;

typedef struct tagMCLUSBToIO__USB_IO_VTable
{
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( MCLUSBToIO__USB_IO_Interface __RPC_FAR * This, 
	                                                         REFIID riid, 
	                                                         void __RPC_FAR *__RPC_FAR *ppvObject);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( MCLUSBToIO__USB_IO_Interface __RPC_FAR * This);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( MCLUSBToIO__USB_IO_Interface __RPC_FAR * This);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfoCount )( MCLUSBToIO__USB_IO_Interface __RPC_FAR * This, 
	                                                           UINT __RPC_FAR *pctinfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfo )( MCLUSBToIO__USB_IO_Interface __RPC_FAR * This, 
	                                                      UINT iTInfo, 
	                                                      LCID lcid, 
	                                                      ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetIDsOfNames )( MCLUSBToIO__USB_IO_Interface __RPC_FAR * This, 
	                                                        REFIID riid, 
	                                                        LPOLESTR __RPC_FAR *rgszNames, 
	                                                        UINT cNames, 
	                                                        LCID lcid, 
	                                                        DISPID __RPC_FAR *rgDispId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Invoke )( MCLUSBToIO__USB_IO_Interface __RPC_FAR * This, 
	                                                 DISPID dispIdMember, 
	                                                 REFIID riid, 
	                                                 LCID lcid, 
	                                                 WORD wFlags, 
	                                                 DISPPARAMS __RPC_FAR *pDispParams, 
	                                                 VARIANT __RPC_FAR *pVarResult, 
	                                                 EXCEPINFO __RPC_FAR *pExcepInfo, 
	                                                 UINT __RPC_FAR *puArgErr);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_SPI_PulseWidth_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                             short *pulsWidth, 
	                                                             short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetByte_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                  BSTR *byteName, 
	                                                  unsigned char *returnedByteVal, 
	                                                  short *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Get_Available_SN_List_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                                BSTR *SN_List, 
	                                                                short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_ModelName_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                         BSTR *modelName, 
	                                                         short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_SN_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                  BSTR *SN, 
	                                                  short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_Byte_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                   BSTR *byteName, 
	                                                   short *byteVal, 
	                                                   short *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SPI_OUT_Trigg_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                        BSTR *regData, 
	                                                        short *trigger, 
	                                                        short *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SPI_OUT_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                  BSTR *clockBit, 
	                                                  BSTR *dataBit, 
	                                                  BSTR *LEBit, 
	                                                  BSTR *regData, 
	                                                  short *arg5);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_ByteA_As_Input_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                             short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_ByteB_As_Input_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                             short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_ByteA_As_Output_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                              short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_ByteB_As_Output_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                              short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_ByteA_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                    unsigned char *val, 
	                                                    short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ReadByteA_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                    unsigned char *ret_ByteVal, 
	                                                    short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_Relays_Byte_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                           unsigned char *retVal, 
	                                                           short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ReadByteB_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                    unsigned char *ret_ByteVal, 
	                                                    short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ReadBit_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                  BSTR *bitRequest, 
	                                                  unsigned char *ret_BitVal, 
	                                                  short *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_ByteB_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                    unsigned char *val, 
	                                                    short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_RelayByte_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                        unsigned char *val, 
	                                                        short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_Relay_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                    short *relayNo, 
	                                                    short *on_OFF, 
	                                                    short *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_TTLBit_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                     BSTR *bitName, 
	                                                     short *bitVal, 
	                                                     short *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Connect_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This, 
	                                                  BSTR *SN, 
	                                                  short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Disconnect_) (MCLUSBToIO__USB_IO_Interface __RPC_FAR *This);

} MCLUSBToIO__USB_IO_VTable;

typedef interface tagMCLUSBToIO__USB_IO_Interface
{
	CONST_VTBL MCLUSBToIO__USB_IO_VTable __RPC_FAR *lpVtbl;
} MCLUSBToIO__USB_IO_Interface;

const IID MCLUSBToIO_IID__USB_IO =
	{
		0x1D339496, 0xDD53, 0x4C38, 0x9C, 0xA3, 0x9D, 0x86, 0x58, 0x33, 0xC6, 0xD2
	};

HRESULT CVIFUNC MCLUSBToIO_New_USB_IO (const char *server,
                                       int supportMultithreading, LCID locale,
                                       int reserved, CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x56DB0536, 0xBD46, 0x45FE, 0xB0, 0x78, 0x35, 0x63, 0x47,
	              0x1E, 0x10, 0x6D};

	__result = CA_CreateObjectByClassIdEx (&clsid, server,
	                                       &MCLUSBToIO_IID__USB_IO,
	                                       supportMultithreading, locale,
	                                       reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLUSBToIO_Open_USB_IO (const char *fileName, const char *server,
                                        int supportMultithreading, LCID locale,
                                        int reserved, CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x56DB0536, 0xBD46, 0x45FE, 0xB0, 0x78, 0x35, 0x63, 0x47,
	              0x1E, 0x10, 0x6D};

	__result = CA_LoadObjectFromFileByClassIdEx (fileName, &clsid, server,
	                                             &MCLUSBToIO_IID__USB_IO,
	                                             supportMultithreading, locale,
	                                             reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLUSBToIO_Active_USB_IO (const char *server,
                                          int supportMultithreading, LCID locale,
                                          int reserved,
                                          CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x56DB0536, 0xBD46, 0x45FE, 0xB0, 0x78, 0x35, 0x63, 0x47,
	              0x1E, 0x10, 0x6D};

	__result = CA_GetActiveObjectByClassIdEx (&clsid, server,
	                                          &MCLUSBToIO_IID__USB_IO,
	                                          supportMultithreading, locale,
	                                          reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_SPI_PulseWidth (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      short *pulsWidth,
                                                      short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_SPI_PulseWidth_ (__vtblIFacePtr,
	                                                         pulsWidth,
	                                                         &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOGetByte (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, char **byteName,
                                           unsigned char *returnedByteVal,
                                           short *arg3)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR byteName__AutoType = 0;
	short arg3__Temp;

	__caErrChk (CA_CStringToBSTR (*byteName, &byteName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetByte_ (__vtblIFacePtr,
	                                              &byteName__AutoType,
	                                              returnedByteVal, &arg3__Temp));

	if (byteName)
		{
		CA_FreeMemory (*byteName);
		*byteName = 0;
		}
	if (byteName)
		__caErrChk (CA_BSTRGetCString (byteName__AutoType, byteName));
	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	CA_FreeBSTR (byteName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (byteName)
			{
			CA_FreeMemory (*byteName);
			*byteName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOGet_Available_SN_List (CAObjHandle objectHandle,
                                                         ERRORINFO *errorInfo,
                                                         char **SN_List,
                                                         short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN_List__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*SN_List, &SN_List__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Get_Available_SN_List_ (__vtblIFacePtr,
	                                                            &SN_List__AutoType,
	                                                            &arg2__Temp));

	if (SN_List)
		{
		CA_FreeMemory (*SN_List);
		*SN_List = 0;
		}
	if (SN_List)
		__caErrChk (CA_BSTRGetCString (SN_List__AutoType, SN_List));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN_List__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (SN_List)
			{
			CA_FreeMemory (*SN_List);
			*SN_List = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IORead_ModelName (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  char **modelName, short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR modelName__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*modelName, &modelName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_ModelName_ (__vtblIFacePtr,
	                                                     &modelName__AutoType,
	                                                     &arg2__Temp));

	if (modelName)
		{
		CA_FreeMemory (*modelName);
		*modelName = 0;
		}
	if (modelName)
		__caErrChk (CA_BSTRGetCString (modelName__AutoType, modelName));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (modelName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (modelName)
			{
			CA_FreeMemory (*modelName);
			*modelName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IORead_SN (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, char **SN,
                                           short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*SN, &SN__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_SN_ (__vtblIFacePtr,
	                                              &SN__AutoType, &arg2__Temp));

	if (SN)
		{
		CA_FreeMemory (*SN);
		*SN = 0;
		}
	if (SN)
		__caErrChk (CA_BSTRGetCString (SN__AutoType, SN));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (SN)
			{
			CA_FreeMemory (*SN);
			*SN = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_Byte (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            char **byteName, short *byteVal,
                                            short *arg3)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR byteName__AutoType = 0;
	short arg3__Temp;

	__caErrChk (CA_CStringToBSTR (*byteName, &byteName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_Byte_ (__vtblIFacePtr,
	                                               &byteName__AutoType,
	                                               byteVal, &arg3__Temp));

	if (byteName)
		{
		CA_FreeMemory (*byteName);
		*byteName = 0;
		}
	if (byteName)
		__caErrChk (CA_BSTRGetCString (byteName__AutoType, byteName));
	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	CA_FreeBSTR (byteName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (byteName)
			{
			CA_FreeMemory (*byteName);
			*byteName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSPI_OUT_Trigg (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **regData, short *trigger,
                                                 short *arg3)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR regData__AutoType = 0;
	short arg3__Temp;

	__caErrChk (CA_CStringToBSTR (*regData, &regData__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SPI_OUT_Trigg_ (__vtblIFacePtr,
	                                                    &regData__AutoType,
	                                                    trigger, &arg3__Temp));

	if (regData)
		{
		CA_FreeMemory (*regData);
		*regData = 0;
		}
	if (regData)
		__caErrChk (CA_BSTRGetCString (regData__AutoType, regData));
	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	CA_FreeBSTR (regData__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (regData)
			{
			CA_FreeMemory (*regData);
			*regData = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSPI_OUT (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, char **clockBit,
                                           char **dataBit, char **LEBit,
                                           char **regData, short *arg5)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR clockBit__AutoType = 0;
	BSTR dataBit__AutoType = 0;
	BSTR LEBit__AutoType = 0;
	BSTR regData__AutoType = 0;
	short arg5__Temp;

	__caErrChk (CA_CStringToBSTR (*clockBit, &clockBit__AutoType));
	__caErrChk (CA_CStringToBSTR (*dataBit, &dataBit__AutoType));
	__caErrChk (CA_CStringToBSTR (*LEBit, &LEBit__AutoType));
	__caErrChk (CA_CStringToBSTR (*regData, &regData__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SPI_OUT_ (__vtblIFacePtr,
	                                              &clockBit__AutoType,
	                                              &dataBit__AutoType,
	                                              &LEBit__AutoType,
	                                              &regData__AutoType,
	                                              &arg5__Temp));

	if (clockBit)
		{
		CA_FreeMemory (*clockBit);
		*clockBit = 0;
		}
	if (clockBit)
		__caErrChk (CA_BSTRGetCString (clockBit__AutoType, clockBit));
	if (dataBit)
		{
		CA_FreeMemory (*dataBit);
		*dataBit = 0;
		}
	if (dataBit)
		__caErrChk (CA_BSTRGetCString (dataBit__AutoType, dataBit));
	if (LEBit)
		{
		CA_FreeMemory (*LEBit);
		*LEBit = 0;
		}
	if (LEBit)
		__caErrChk (CA_BSTRGetCString (LEBit__AutoType, LEBit));
	if (regData)
		{
		CA_FreeMemory (*regData);
		*regData = 0;
		}
	if (regData)
		__caErrChk (CA_BSTRGetCString (regData__AutoType, regData));
	if (arg5)
		{
		*arg5 = arg5__Temp;
		}

Error:
	CA_FreeBSTR (clockBit__AutoType);
	CA_FreeBSTR (dataBit__AutoType);
	CA_FreeBSTR (LEBit__AutoType);
	CA_FreeBSTR (regData__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (clockBit)
			{
			CA_FreeMemory (*clockBit);
			*clockBit = 0;
			}
		if (dataBit)
			{
			CA_FreeMemory (*dataBit);
			*dataBit = 0;
			}
		if (LEBit)
			{
			CA_FreeMemory (*LEBit);
			*LEBit = 0;
			}
		if (regData)
			{
			CA_FreeMemory (*regData);
			*regData = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_ByteA_As_Input (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      short *arg1)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_ByteA_As_Input_ (__vtblIFacePtr,
	                                                         &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_ByteB_As_Input (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      short *arg1)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_ByteB_As_Input_ (__vtblIFacePtr,
	                                                         &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_ByteA_As_Output (CAObjHandle objectHandle,
                                                       ERRORINFO *errorInfo,
                                                       short *arg1)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_ByteA_As_Output_ (__vtblIFacePtr,
	                                                          &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_ByteB_As_Output (CAObjHandle objectHandle,
                                                       ERRORINFO *errorInfo,
                                                       short *arg1)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_ByteB_As_Output_ (__vtblIFacePtr,
	                                                          &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_ByteA (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             unsigned char *val, short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_ByteA_ (__vtblIFacePtr, val,
	                                                &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOReadByteA (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             unsigned char *ret_ByteVal,
                                             short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->ReadByteA_ (__vtblIFacePtr,
	                                                ret_ByteVal, &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IORead_Relays_Byte (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    unsigned char *retVal,
                                                    short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_Relays_Byte_ (__vtblIFacePtr,
	                                                       retVal, &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOReadByteB (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             unsigned char *ret_ByteVal,
                                             short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->ReadByteB_ (__vtblIFacePtr,
	                                                ret_ByteVal, &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOReadBit (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **bitRequest,
                                           unsigned char *ret_BitVal,
                                           short *arg3)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bitRequest__AutoType = 0;
	short arg3__Temp;

	__caErrChk (CA_CStringToBSTR (*bitRequest, &bitRequest__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->ReadBit_ (__vtblIFacePtr,
	                                              &bitRequest__AutoType,
	                                              ret_BitVal, &arg3__Temp));

	if (bitRequest)
		{
		CA_FreeMemory (*bitRequest);
		*bitRequest = 0;
		}
	if (bitRequest)
		__caErrChk (CA_BSTRGetCString (bitRequest__AutoType, bitRequest));
	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	CA_FreeBSTR (bitRequest__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bitRequest)
			{
			CA_FreeMemory (*bitRequest);
			*bitRequest = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_ByteB (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             unsigned char *val, short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_ByteB_ (__vtblIFacePtr, val,
	                                                &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_RelayByte (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 unsigned char *val, short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_RelayByte_ (__vtblIFacePtr, val,
	                                                    &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_Relay (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             short *relayNo, short *on_OFF,
                                             short *arg3)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg3__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_Relay_ (__vtblIFacePtr, relayNo,
	                                                on_OFF, &arg3__Temp));

	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOSet_TTLBit (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              char **bitName, short *bitVal,
                                              short *arg3)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bitName__AutoType = 0;
	short arg3__Temp;

	__caErrChk (CA_CStringToBSTR (*bitName, &bitName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_TTLBit_ (__vtblIFacePtr,
	                                                 &bitName__AutoType,
	                                                 bitVal, &arg3__Temp));

	if (bitName)
		{
		CA_FreeMemory (*bitName);
		*bitName = 0;
		}
	if (bitName)
		__caErrChk (CA_BSTRGetCString (bitName__AutoType, bitName));
	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	CA_FreeBSTR (bitName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bitName)
			{
			CA_FreeMemory (*bitName);
			*bitName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IOConnect (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, char **SN,
                                           short *arg2)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*SN, &SN__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Connect_ (__vtblIFacePtr,
	                                              &SN__AutoType, &arg2__Temp));

	if (SN)
		{
		CA_FreeMemory (*SN);
		*SN = 0;
		}
	if (SN)
		__caErrChk (CA_BSTRGetCString (SN__AutoType, SN));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (SN)
			{
			CA_FreeMemory (*SN);
			*SN = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLUSBToIO__USB_IODisconnect (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;
	MCLUSBToIO__USB_IO_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLUSBToIO_IID__USB_IO, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Disconnect_ (__vtblIFacePtr));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLUSBToIO_IID__USB_IO, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}
