unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,MCL_USB_To_IO_TLB,MATH;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    GroupBox1: TGroupBox;
    PortA: TRadioButton;
    PortB: TRadioButton;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button9: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure PortAClick(Sender: TObject);
    procedure PortBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MyIO:USB_IO;
  PortName:AnsiChar;
  status:Integer;
  ByteArr:array[0..7] of integer   ;




implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
        SN:WideString  ;
        i:integer;
begin
        SN:= '';
        MyIO := CoUSB_IO.Create;
        status:= MyIO.Connect(SN);

        for i:= 0 to 7 do
                ByteArr[i]:= 0;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
        if (ByteArr[0] = 0) then
         begin
            Button1.Caption:= '1';
            ByteArr[0]:= 1;

         end

        else
            begin
              Button1.Caption:= '0';
              ByteArr[0]:= 0;
            end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
      if (ByteArr[1] = 0) then
         begin
            Button2.Caption:= '1';
            ByteArr[1]:= 1;

         end

        else
            begin
              Button2.Caption:= '0';
              ByteArr[1]:= 0;
            end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
      if (ByteArr[2] = 0) then
         begin
            Button3.Caption:= '1';
            ByteArr[2]:= 1;

         end

        else
            begin
              Button3.Caption:= '0';
              ByteArr[2]:= 0;
            end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
       if (ByteArr[3] = 0) then
         begin
            Button4.Caption:= '1';
            ByteArr[3]:= 1;

         end

        else
            begin
              Button4.Caption:= '0';
              ByteArr[3]:= 0;
            end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
       if (ByteArr[4] = 0) then
         begin
            Button5.Caption:= '1';
            ByteArr[4]:= 1;

         end

        else
            begin
              Button5.Caption:= '0';
              ByteArr[4]:= 0;
            end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
        if (ByteArr[5] = 0) then
         begin
            Button6.Caption:= '1';
            ByteArr[5]:= 1;

         end

        else
            begin
              Button6.Caption:= '0';
              ByteArr[5]:= 0;
            end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
       if (ByteArr[6] = 0) then
         begin
            Button7.Caption:= '1';
            ByteArr[6]:= 1;

         end

        else
            begin
              Button7.Caption:= '0';
              ByteArr[6]:= 0;
            end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
        if (ByteArr[7] = 0) then
         begin
            Button8.Caption:= '1';
            ByteArr[7]:= 1;

         end

        else
            begin
              Button8.Caption:= '0';
              ByteArr[7]:= 0;
            end;
end;




function Pow(x,y:integer):integer;
var
 i,res:Integer;

begin
    res:=1 ;
    for i:= 1 to y do
        res:=res*x;


    Result:= res;



end;

function CalcByte() : byte ;
var
   res:Byte;
   i:Integer;
   b:Integer;

begin
     res:= 0;
    for i:= 0 to 7 do
    begin

        res:= res + ByteArr[i]* Pow(2,i) ;


    end;

   Result := res;


end;

procedure TForm1.Button9Click(Sender: TObject);
var
  b:Byte;
begin

        b:= CalcByte();

        if PortName = 'A' then
                status:= MyIO.Set_ByteA(b);

        if PortName = 'B' then
                status:= MyIO.Set_ByteB(b);
end;

procedure TForm1.PortAClick(Sender: TObject);
begin
        status:= MyIO.Set_ByteA_As_Output;
        PortName:= 'A';
end;

procedure TForm1.PortBClick(Sender: TObject);
begin
        status:= MyIO.Set_ByteB_As_Output;
        PortName:= 'B';

end;

end.
