using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using mcl_USB_To_IO_64;

namespace MclIoExm
{
    public partial class Form1 : Form
    {
        mcl_USB_To_IO_64.USB_IO MyIo = new mcl_USB_To_IO_64.USB_IO();
        int status;
        char PortName;
        byte[] ByteArr = new byte[8];



        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string SN="";
            status = MyIo.Connect(ref(SN));

            for (int i = 0; i < 8; i++)
                ByteArr[i] = 0;
        }

        private void PortA_CheckedChanged(object sender, EventArgs e)
        {
            status = MyIo.Set_ByteA_As_Output();
            PortName = 'A';
        }

        private void PortB_CheckedChanged(object sender, EventArgs e)
        {
            status = MyIo.Set_ByteB_As_Output();
            PortName = 'B';
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (ByteArr[0] == 0)
            {
                ByteArr[0] = 1;
                button1.Text = "1";

            }
            else
            {
                ByteArr[0] = 0;
                button1.Text = "0";
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (ByteArr[1] == 0)
            {
                ByteArr[1] = 1;
                button2.Text = "1";

            }
            else
            {
                ByteArr[1] = 0;
                button2.Text = "0";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (ByteArr[2] == 0)
            {
                ByteArr[2] = 1;
                button3.Text = "1";

            }
            else
            {
                ByteArr[2] = 0;
                button3.Text = "0";
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (ByteArr[3] == 0)
            {
                ByteArr[3] = 1;
                button4.Text = "1";

            }
            else
            {
                ByteArr[3] = 0;
                button4.Text = "0";
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (ByteArr[4] == 0)
            {
                ByteArr[4] = 1;
                button5.Text = "1";

            }
            else
            {
                ByteArr[4] = 0;
                button5.Text = "0";
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (ByteArr[5] == 0)
            {
                ByteArr[5] = 1;
                button6.Text = "1";

            }
            else
            {
                ByteArr[5] = 0;
                button6.Text = "0";
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (ByteArr[6] == 0)
            {
                ByteArr[6] = 1;
                button7.Text = "1";

            }
            else
            {
                ByteArr[6] = 0;
                button7.Text = "0";
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            if (ByteArr[7] == 0)
            {
                ByteArr[7] = 1;
                button8.Text = "1";

            }
            else
            {
                ByteArr[7] = 0;
                button8.Text = "0";
            }
        }


        private byte CalcByte()
        {
            byte res=0;
            for (int i = 0; i < 8; i++)
                res += (byte)(ByteArr[i] * (Math.Pow(2, i)));
            
            return res;




        }


        private void SendButton_Click(object sender, EventArgs e)
        {
            byte b = CalcByte();
            switch (PortName)
            {
                case 'A':
                    status = MyIo.Set_ByteA(ref(b));
                    break;

                case 'B':
                    status = MyIo.Set_ByteB(ref(b));
                    break;
            }
        }
    }
}